#include    "unpthread.h"
#include	"unp.h"
#include    "pusher.h"
#include    "queue.h"

int     sockfd;

struct client_shared client_shared = { PTHREAD_MUTEX_INITIALIZER };

void left_read(int sockfd,int receiver_sockfd);
void right_read(int sockfd);
int PopSocket(struct sock_fd** headRef); 

void init()
{
    client_shared.vlc_connect_ptr = &client_shared.vlc_connect_str[0];
    client_shared.vlc_temp_connect_ptr = &client_shared.vlc_connect_str[0];
    client_shared.get_connection_string = 0 ;
    client_shared.put_connection_string = 0 ;
    client_shared.connection_string_len = 0 ;
    client_shared.count_frames = 0 ;
    frames = NULL;
}

void create_right_client()
{
  void    *right_thread_client_main(void *);
  
  nthreads = 1;
  tptr = Calloc(nthreads, sizeof(Thread));
  Pthread_create(&tptr[0].thread_tid, NULL, &right_thread_client_main, (void *) 0);
  return;     /* main thread returns */
}

void create_left_client(int sockfd)
{
  void    *left_thread_client_main(void *);
  
  nthreads = 1;
  tptr = Calloc(nthreads, sizeof(Thread));
  Pthread_create(&tptr[1].thread_tid, NULL, &left_thread_client_main, (void *) sockfd);
  //pthread_join(tptr[1].thread_tid,NULL);
  return;     /* main thread returns */
}

void * left_thread_client_main(void *arg)
{
    int             connfd = 0 ;
    void            web_child(int);
    struct sockaddr *cliaddr;

    int receiver_sockfd = (int) (void*)arg;

    cliaddr = Malloc(addrlen_left);

    for ( ; ; ) 
    {
        sockfd = Tcp_connect((char*)"127.0.0.1", (char*)"8003");
        if (sockfd > 0)
        {
            printf("left client connect sockfd=%d  receiver_sockfd=%d\n",sockfd,receiver_sockfd);
            left_read(sockfd,receiver_sockfd);
        }
        else
        {
            printf ("... left client reconnect \n");
        }


        if(connfd>0)
        {
            Close(connfd);
            Pthread_mutex_lock(&client_shared.mutex);
            Pthread_mutex_unlock(&client_shared.mutex);
        }

        sleep(1);

        
    }


}

void * right_thread_client_main(void *arg)
{
    int             connfd = 0 ;
    void            web_child(int);
    struct sockaddr *cliaddr;
    int sockfd;

    cliaddr = Malloc(addrlen_right);
    tptr[(int) arg].thread_count++;

    for ( ; ; ) 
    {
        
        sockfd = Tcp_connect((char*)"127.0.0.1", (char*)"8005");
        if (sockfd > 0)
        {
            printf ("right client connect  sockfd=%d\n",sockfd);
            right_read(sockfd);    
        }
        else
        {
             printf ("... right client reconnect \n");
        }
        
        if(connfd>0)
            Close(connfd);

        sleep(1);

    }
}


int check_left_server()
{
    int result = 0 ;
    Pthread_mutex_lock(&client_shared.mutex);
    if(client_shared.get_connection_string == 1)
        result = 1;
    Pthread_mutex_unlock(&client_shared.mutex);
    return result ; 
    
}


int main(int argc, char **argv)
{


    init();
    create_right_client();

    int pop_result = 0 ;

    for ( ; ; )
    {

        Pthread_mutex_lock(&_socket.mutex);
        pop_result = PopSocket(&_socket.sockets);
        Pthread_mutex_unlock(&_socket.mutex);

        if(pop_result>0)
        {
            create_left_client(pop_sock_fd.sockfd);
        }

        sleep(1);

    }


}

// vlc -vvv 21.mp4 --sout '#standard{access=http,mux=asf,dst=127.0.0.1:8003}'
