/* include readline */
#include	"../unp.h"

ssize_t
readline(int fd, void *vptr, size_t maxlen)
{
	ssize_t	n, rc;
	char	c, *ptr;

    //printf("readline 1\n");

	ptr = vptr;
	for (n = 1; n < maxlen; n++) 
    {
		if ( (rc = read(fd, &c, 1)) == 1) 
        {
			*ptr++ = c;
			if (c == '\n')				break;
		} 
        else if (rc == 0) 
        {
			if (n == 1)
				return(0);	/* EOF, no data read */
			else
				break;		/* EOF, some data was read */
		} 
        else return(0);	/* error */
	}

	*ptr = 0;
	return(n);
}
/* end readline */

ssize_t readconnectstr(int fd, void *vptr, size_t maxlen)
{
    ssize_t n, rc;
    char    c, *ptr;

    //printf("readline 1\n");

    printf ("ReadConnectStr\n");

    ptr = vptr;
    for (n = 1; n < maxlen; n++) 
    {
        //printf ("%d\n",n);
        if ( (rc = read(fd, &c, 1)) == 1) 
        {
            *ptr++ = c;

            //printf ("%s",*ptr);
        } 
        else if (rc == 0) 
        {
            //if (n == 1)
            break;  /* EOF, no data read */
//            else
//                break;      /* EOF, some data was read */
        } 
        //else return(-1);    /* error */
    }

    *ptr = 0;

    //printf("\n%s\n",*ptr);

    return(n);
}


ssize_t 
ReadConnectStr(int fd, void *ptr, size_t maxlen)
{
	ssize_t		n;


	if ( (n = readconnectstr(fd, ptr, maxlen)) == -1)
    {
		//err_sys("readline error");
    }

    //printf("ptr=%s  len=%d\n",ptr,strlen(ptr));

	return(n);
}



ssize_t 
Readline0(int fd, void *ptr, size_t maxlen)
{
    ssize_t     n;


    if ( (n = readline(fd, ptr, maxlen)) == -1)
    {
        //err_sys("readline error");
    }    

    //printf("ptr=%s  len=%d\n",ptr,strlen(ptr));

    return(n);
}

ssize_t 
Readline(int fd, void *ptr, size_t maxlen)
{
    ssize_t     n;

//   if ( (n = read(fd, ptr, maxlen)) < 0) 
   {
//        return -1 ;
   } 

   

    if ( (n = readline(fd, ptr, maxlen)) == -1)
    {
        //err_sys("readline error");
    }    

    //printf("ptr=%s  len=%d\n",ptr,strlen(ptr));

    return(n);
}


ssize_t                     /* Read "n" bytes from a descriptor. */
readn(int fd, void *vptr, size_t n)
{
    size_t  nleft;
    ssize_t nread;
    char    *ptr;

    ptr = vptr;
    nleft = n;
    while (nleft > 0) 
    {
        if ( (nread = read(fd, ptr, nleft)) < 0) 
        {
            if (errno == EINTR)
                nread = 0;      /* and call read() again */
            else
                return(-1);
        } else if (nread == 0)
            break;              /* EOF */

        nleft -= nread;
        ptr   += nread;
    }
    return(n - nleft);      /* return >= 0 */
}
/* end readn */

ssize_t
Readn(int fd, void *ptr, size_t nbytes)
{
    ssize_t     n;

    if ( (n = readn(fd, ptr, nbytes)) < 0)
        err_sys("readn error");
    return(n);
}
