#include <stdio.h>
#include <stdlib.h>
#include "unpthread.h"
#include    "pusher.h"
#include "queue.h"

struct node * frames ;

struct _socket _socket         = { PTHREAD_MUTEX_INITIALIZER };
struct frame frame             = { PTHREAD_MUTEX_INITIALIZER };

struct pop_sock_fd pop_sock_fd;

char buf[4];

void AddFrameClient(struct node** headRef, 
              char * buffer,
              int len, 
              int receiver_sockfd) 
{
    
   struct node* current = *headRef;
   struct node* newNode;
   newNode = malloc(sizeof(struct node));

   newNode->len = len;
   newNode->sockfd = receiver_sockfd;
   snprintf((char*)&buf,4,"%d",receiver_sockfd); 
   memcpy(&newNode->buffer, &buf, 4);
   memcpy(&newNode->buffer[4], (char *) buffer, len);



   newNode->next = NULL;
   // special case for length 0
    if (current == NULL) 
    {
      *headRef = newNode;
    }
   else 
   {
      while (current->next != NULL) 
      {
          current = current->next;
      }
      current->next = newNode;
   }

}

void AddFrameServer(struct node** headRef, 
              char * buffer,
              int len, 
              int sockfd) 
{
    
   struct node* current = *headRef;
   struct node* newNode;
   newNode = malloc(sizeof(struct node));

   newNode->len = len;
   newNode->sockfd = sockfd;
   memcpy(&newNode->buffer, (char *) buffer, len);

   newNode->next = NULL;
   if (current == NULL) 
   {
      *headRef = newNode;
   }
   else 
   {
      while (current->next != NULL) 
      {
          current = current->next;
      }
      current->next = newNode;
   }

}

int IsEmptyFrameClient(struct node** headRef) 
{
   struct node* head;
   head = *headRef;
   
   if (head==NULL) 
   { 
    return 1 ; 
   } 

   return 0 ;
  
}


int PopFrameClient(struct node** headRef,int sockfd) 
{
   struct node* head;
   int result;
   head = *headRef;
   
   if (head==NULL) 
   { 
    return 0 ; 
   } 

   result = head->len; 

   write(sockfd, &head->buffer, head->len+4);

   *headRef = head->next;
   free(head);           // free the head node
   return(result);       
}


int PopFrameServer(struct node** headRef,int sockfd) 
{

   int result = 0;

   struct node* head;
   head = *headRef;
   
   if (head==NULL) 
   {
       return 0 ; 
   }

  
  if (head->sockfd == (int)NULL) return 0 ;

  if(sockfd != head->sockfd ) 
  {
    return 0 ;
  }

   *headRef = head->next;      
   result = write(head->sockfd, &head->buffer, head->len);
    
   free(head);           // free the head node
   return(result);       
}

void AddSocket(struct sock_fd** head, int sockfd, char * connect_str, int len) 
{
    
   struct sock_fd* current = *head;
   struct sock_fd* new = malloc(sizeof(struct sock_fd));
   new->sockfd = sockfd;
   memcpy(new->buffer,connect_str,len);
   new->len = len;
   new->next = NULL;


   if (current == NULL)  *head = new;
   else 
   {
      while (current->next != NULL) 
      {
          current = current->next;
      }
      current->next = new;
   }

}

int PopSocket(struct sock_fd** headRef) 
{
   struct sock_fd* head;
   int result;
   head = *headRef;
   if (head==NULL) 
   { 
    return 0 ; 
   } 
   result = head->sockfd; 

   pop_sock_fd.sockfd = head->sockfd     ;
   pop_sock_fd.len    = head->len     ;
   memcpy(&pop_sock_fd.buffer,head->buffer,head->len);

   *headRef = head->next;
   free(head);           // free the head node
   return(result);       
}


int DelSocket(struct sock_fd ** head,int sockfd)
{

	int _sockfd = 0;
    struct sock_fd * current = *head;
    if (current==NULL) 
    { 
      return 0 ; 
    } 
	if(current->sockfd == (int)NULL) return 0 ;

	_sockfd = current->sockfd;
    if(_sockfd==sockfd) 
    {
      PopSocket(head);
      return sockfd;
    }
	while(current->next !=NULL)
	{
    	current=current->next;
        if(current->sockfd==sockfd) 
        {
          PopSocket(&(current));
          return sockfd;
        }
	}
    return _sockfd;
}


int Length(char * name , struct node* head)
{
   struct node* current = head;
   int count = 0;
   while (current != NULL) 
   {
      count++;
      current = current->next;
   }
   return count;
}
