#include    "unpthread.h"
#include    "unp.h"
#include    "pusher.h"
#include    "queue.h"

#include    <limits.h>      /* for OPEN_MAX */


void AddFrameServer(struct node** headRef, char * buffer,int len, int sockfd); 
int PopSocket(struct sock_fd** headRef); 


void create_left_server()
{
    void    *main_left(void *);

    nthreads = 1;
    tptr = Calloc(nthreads, sizeof(Thread));
    Pthread_create(&tptr[0].thread_tid, NULL, &main_left, (void *) 0);
    return;     /* main thread returns */

}


void signal_after_add_frame(int receiver_sockfd)
{
    Pthread_mutex_lock(&server_shared.mutex);
      server_shared.count_frames ++ ;
    Pthread_cond_signal(&server_shared.cond);
    Pthread_mutex_unlock(&server_shared.mutex);
}


void * main_left(void *arg)
{
    int                 i, maxi, listenfd, connfd, sockfd;
    int                 nready;
    ssize_t             n;
    char                line[MAXLINE];
    socklen_t           clilen;
    struct pollfd       client[OPEN_MAX];
    int                 is_client_connect[OPEN_MAX];
    struct sockaddr_in  cliaddr, servaddr;

    listenfd = Socket(AF_INET, SOCK_STREAM, 0);

    bzero(&servaddr, sizeof(servaddr));
    servaddr.sin_family      = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port        = htons(8005);

    Bind(listenfd, (SA *) &servaddr, sizeof(servaddr));

    Listen(listenfd, LISTENQ);

    client[0].fd = listenfd;
    client[0].events = POLLRDNORM;
    for (i = 1; i < OPEN_MAX; i++)
        client[i].fd = -1;      /* -1 indicates available entry */
    maxi = 0;                   /* max index into client[] array */

    printf ("left server start \n");

    char    empty_for_client[MAXLINE];
    sprintf(empty_for_client," ");

    int pop_result = 0 ;
    int _sockfd = 0;
    int is_connect = 0 ;

    for ( ; ; ) 
    {
        nready = Poll(client, maxi+1, INFTIM);

        if (client[0].revents & POLLRDNORM) 
        {   /* new client connection */
            clilen = sizeof(cliaddr);
            connfd = Accept(listenfd, (SA *) &cliaddr, &clilen);
            printf("new %d ONLINE client: %s\n", i , Sock_ntop((SA *) &cliaddr, clilen));

            for (i = 1; i < OPEN_MAX; i++)
            {
                if (client[i].fd < 0) 
                {
                    client[i].fd = connfd;  /* save descriptor */
                    break;
                }
            }

            if (i == OPEN_MAX)
                err_quit("too many clients");

            client[i].events = POLLRDNORM;
            if (i > maxi)
                maxi = i;               /* max index in client[] array */

            if (--nready <= 0)
                continue;               /* no more readable descriptors */
        }

        //////////////// check all clients for data 
        for (i = 1; i <= maxi; i++) 
        {   
            if ( (sockfd = client[i].fd) < 0) continue;

            if (client[i].revents & (POLLRDNORM | POLLERR)) 
            {

                    if ( (n = read(sockfd, line, MAXLINE)) < 0) 
                    {
                        if (errno == ECONNRESET) 
                        {
                            is_client_connect[i]=0;
                            printf("client[%d] aborted connection\n", i);
                            Close(sockfd);
                            client[i].fd = -1;
                        } 
                        else
                        {            
                            err_sys("readline error");
                        }
                    } 
                    else if (n == 0) 
                    {
                        is_client_connect[i]=0;
                        printf("client[%d] closed connection\n", i);
                        Close(sockfd);
                        client[i].fd = -1;
                    } 
                    else
                    {
                        if(n>1)
                        {
                            _sockfd = atoi((char*)&line);
                            Pthread_mutex_lock(&frame.mutex);
                              AddFrameServer(&frame.frames,(char*)&line[4],n-4,_sockfd);
                            Pthread_mutex_unlock(&frame.mutex);
                            signal_after_add_frame(_sockfd);


                        }

                        Pthread_mutex_lock(&_socket.mutex);
                        pop_result = PopSocket(&_socket.sockets);
                        Pthread_mutex_unlock(&_socket.mutex);

                        if(pop_result>0)
                        {
                            Pthread_mutex_lock(&server_shared.mutex);
                            snprintf((char*)&server_shared.vlc_connect_str,4,"%d",pop_sock_fd.sockfd);
                            memcpy(&server_shared.vlc_connect_str[4],pop_sock_fd.buffer,pop_sock_fd.len);
                            write(sockfd, &server_shared.vlc_connect_str, pop_sock_fd.len+4);
                            Pthread_mutex_unlock(&server_shared.mutex);
                            is_connect = 1 ;
                        }
                        else
                        {
                            write(sockfd, &empty_for_client, 1);
                            if(!is_connect) sleep(1);
                        }


                    } //     n = read



                  if (--nready <= 0)
                    break;              /* no more readable descriptors */
                
              } // if (client[i].revents 

        } // for (i = 1; i <= maxi; i++) 

    }  //     for ( ; ; ) 
}

