#include    "unpthread.h"
#include    "unp.h"
#include    "pusher.h"
#include    "queue.h"

#include    <limits.h>      /* for OPEN_MAX */

int PopFrameServer(struct node** headRef,int sockfd); 
int Length(char * name , struct node* head); 
void AddSocket(struct sock_fd** head, int sockfd, char * connect_str, int len); 
int DelSocket(struct sock_fd ** head,int sockfd);
void clear_connect_string();
void wait_before_pop_frame(int receiver_sockfd);
void signal_after_pop_frame(int receiver_sockfd);
int get_frame(int sockfd);



int get_vlc_connection_string(char * line,int sockfd)
{
    int result = 0 , i;
    Pthread_mutex_lock(&server_shared.mutex);
        for(i=0;i<strlen(line);i++)
            *server_shared.vlc_temp_connect_ptr++ = line[i];

        server_shared.connection_string_len += strlen(line); ;

        if(server_shared.connection_string_len==168)
        {
            server_shared.get_connection_string = 1;
            result = 1 ;

            Pthread_mutex_lock(&_socket.mutex);
            AddSocket(&_socket.sockets,sockfd,(char*)&server_shared.vlc_connect_str,server_shared.connection_string_len); 
            Pthread_mutex_unlock(&_socket.mutex);

            clear_connect_string();

        }
    Pthread_mutex_unlock(&server_shared.mutex);
    return result ;

}

void create_right_server()
{
    void    *main_right(void *);

    nthreads = 1;
    tptr = Calloc(nthreads, sizeof(Thread));
    Pthread_create(&tptr[0].thread_tid, NULL, &main_right, (void *) 0);
    return;     /* main thread returns */

}

void write_frame(int sockfd)
{
    int pop_result = 0 ;
    wait_before_pop_frame(sockfd);
    
    pop_result = get_frame(sockfd);
    if(pop_result>0)
    {
      signal_after_pop_frame(sockfd);
    }
}

int get_frame(int sockfd)
{
    int pop_result = 0 ;

    Pthread_mutex_lock(&frame.mutex);
    pop_result = PopFrameServer(&frame.frames,sockfd) ;
//    if(pop_result>0)
//      printf ("len=%d\n",pop_result);
    Pthread_mutex_unlock(&frame.mutex);
    return pop_result;
}

long summa = 0 ;

void clear_connect_string()
{
    server_shared.vlc_temp_connect_ptr = &server_shared.vlc_connect_str[0];
    server_shared.get_connection_string = 0 ;
    server_shared.connection_string_len = 0 ;
}


void wait_before_pop_frame(int receiver_sockfd)
{
    Pthread_mutex_lock(&server_shared.mutex);
      while(server_shared.count_frames ==0)
        Pthread_cond_wait(&server_shared.cond, &server_shared.mutex);
    Pthread_mutex_unlock(&server_shared.mutex);
}

void signal_after_pop_frame(int receiver_sockfd)
{
    Pthread_mutex_lock(&server_shared.mutex);
    server_shared.count_frames -- ;
    Pthread_cond_signal(&server_shared.cond);
    Pthread_mutex_unlock(&server_shared.mutex);
}


void * main_right(void *arg)
{
    int                 i, maxi, listenfd, connfd, sockfd;
    int                 nready;
    ssize_t             n;
    char                line[MAXLINE];
    socklen_t           clilen;
    struct pollfd       client[OPEN_MAX];
    struct sockaddr_in  cliaddr, servaddr;

    listenfd = Socket(AF_INET, SOCK_STREAM, 0);

    bzero(&servaddr, sizeof(servaddr));
    servaddr.sin_family      = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port        = htons(8007);

    Bind(listenfd, (SA *) &servaddr, sizeof(servaddr));

    Listen(listenfd, LISTENQ);

    client[0].fd = listenfd;
    client[0].events = POLLRDNORM;
    for (i = 1; i < OPEN_MAX; i++)
        client[i].fd = -1;      /* -1 indicates available entry */
    maxi = 0;                   /* max index into client[] array */

    printf ("right server start \n");

    int del;

    for ( ; ; ) 
    {
        
        nready = Poll(client, maxi+1, INFTIM);

        if (client[0].revents & POLLRDNORM) 
        {   /* new client connection */
            clilen = sizeof(cliaddr);
            connfd = Accept(listenfd, (SA *) &cliaddr, &clilen);
            printf("new VLC client: %d\n", connfd);


            for (i = 1; i < OPEN_MAX; i++)
                if (client[i].fd < 0) {
                    client[i].fd = connfd;  /* save descriptor */
                    break;
                }

            
            if (i == OPEN_MAX)
                err_quit("too many clients");

            client[i].events = POLLRDNORM;
            if (i > maxi)
                maxi = i;               /* max index in client[] array */

            if (--nready <= 0)
                continue;               /* no more readable descriptors */
        }


        for (i = 1; i <= maxi; i++) 
        { 
            
            if ( (sockfd = client[i].fd) < 0) continue;

                if (client[i].revents & (POLLRDNORM | POLLERR)) 
                {
/*
                  if (errno == ECONNRESET) 
                  {
        
                      int res = write(sockfd,(char *)" ",1);
                      printf("abort VLC [%d] %d\n", sockfd,res);
                      if(res==-1)
                      {
                        printf("close VLC [%d] \n", sockfd);
                        Close(sockfd);
                        client[i].fd = -1;
                      }
                  } 
*/

                    if(!server_shared.is_start[i])
                    {
                        if ( (n = readline(sockfd, line, MAXLINE)) < 0) 
                        {
                            if (errno == ECONNRESET) 
                            {
                                printf("VLC client[%d] aborted connection\n", i);
                                Close(sockfd);
                                client[i].fd = -1;
                                Pthread_mutex_lock(&_socket.mutex);
                                del = DelSocket(&_socket.sockets,sockfd); 
                                Pthread_mutex_unlock(&_socket.mutex);
                            } 
                            else
                            {            
                                err_sys("VLC readline error");
                            }
                        } 
                        else if (n == 0) 
                        {
                            printf("VLC client[%d] closed connection\n", sockfd);
                            Close(sockfd);
                            client[i].fd = -1;
                            Pthread_mutex_lock(&_socket.mutex);
                            del = DelSocket(&_socket.sockets,sockfd); 
                            Pthread_mutex_unlock(&_socket.mutex);
                        } 
                        else
                        {
                            if(get_vlc_connection_string((char *)line,sockfd))
                            {
                              server_shared.is_start[i] = 1;
                              printf("right server get connect string  \n"); 
                            }
                        }
                      }
                      else
                      {
                        //if(!server_shared.is_close[sockfd])
                          write_frame(sockfd);
                      }
    
                    if (--nready <= 0)
                        break;              /* no more readable descriptors */
                } 

              //write_frame(sockfd);

        } // for ( i


    } // for(;;)
}

